Attribute VB_Name = "BufferedFileOperations"
Option Explicit

Global cof_lblSizeCompared As Label
Global cof_BufferSize&


'DESC  It is already assumed that files have
'      equal sizes.
'
'
Public Function compare_files( _
       sf$, rf$, Excep$) As Boolean
Dim sh%, rh%, slength&, rlength&
Dim r_portion$, portion$, espot$
Dim s_start&, size_to_read&
Dim i&

On Error GoTo he
 
compare_files = True
espot = "start"
 
sh = FreeFile
espot = "source"
Open sf For Binary As #sh
 
espot = "slength"
slength = LOF(sh)
 
espot = "result"
rh = FreeFile
Open rf For Binary As #rh
    
s_start = 1
size_to_read = slength - s_start + 1

If Not cof_lblSizeCompared Is Nothing Then _
   cof_lblSizeCompared.Caption = CStr(s_start)
    
Do While size_to_read > 0
       
   DoEvents
   If size_to_read > cof_BufferSize Then _
      size_to_read = cof_BufferSize
   espot = "read portion; start=" & s_start _
   & " size_to_read=" & size_to_read
    
   portion = Space(size_to_read)
   r_portion = Space(size_to_read)
   Get #sh, s_start, portion
   DoEvents
   Get #rh, s_start, r_portion
      
   DoEvents
   If portion <> r_portion Then
      compare_files = False
      GoTo ExitFunction
   End If


   '-----------------------------------------------
   ' process statistics:
   If glCountBites Then
      BytesCounter = BytesCounter + _
        size_to_read
   End If
   i = GetTickCount - prof_StartTime
   prof_lblTimeElapsed.Caption = _
     CStr(i)
   prof_lblCurrentTotalBytes.Caption = _
     CStr(BytesCounter)
   prof_lblAverageSpeed.Caption = _
     Format(0.001 * BytesCounter / i, "#.000")
   '-----------------------------------------------

   s_start = s_start + size_to_read
   
   '-----------------------------------------------
   'statistics again:
   'must provide this object:
   'If Not cof_lblSizeCompared Is Nothing Then
   cof_lblSizeCompared.Caption = _
     CStr(s_start)
   '-----------------------------------------------
   
   size_to_read = slength - s_start + 1
   
   If STOP_commanded Then GoTo ExitFunction
Loop
    
ExitFunction:
Close #sh, #rh
 
'caller must do this:
'prof_lblTimeElapsed = _
'   CStr(GetTickCount - prof_StartTime)

Exit Function
 
he: Excep = _
       "Exception " & Err.Number & _
       " " & Err.Description & ve & _
       "in compare_files at location: " & ve & _
       espot$
    compare_files = False
    Exit Function
    
End Function

