Attribute VB_Name = "ProcessFolderModule"
Option Explicit

Public Const p_AllAttr As Long = _
    vbDirectory Or vbHidden Or vbSystem Or _
    vbReadOnly

Public Const p_AllFAttr As Long = _
    vbHidden Or vbSystem Or vbReadOnly


Global profold_Deepness&
Global LocalPathInProgress$      'Parent_for_source_folder/LocalPathInProgress/FileInProgress
Global prof_StartTime&

Global PathedParent$
Global Source_OwnName$

Global TargetsPathedParent$
'Must be: TargetsSource_OwnName = Source_OwnName
Global TargetSource_OwnName$

Global STOP_commanded As Boolean
Global ExceptionInProcessFolder$

Global prof_lblCounter As Label
Global prof_lblLocalPath As Label
Global prof_lblCurrentUnit As Label
Global prof_lblTimeElapsed As Label
Global prof_lblCurrentTotalBytes As Label
Global prof_lblAverageSpeed As Label
Global prof_lblTotalFileSize



'EXCE free
'
'
Public Function DontCountExtension(fn$) As Boolean
  
  Dim wi&, wii&, wextension$
  
  DontCountExtension = False
  wi = instrrevv(fn, "\")
  wii = instrrevv(fn, ".")
  If 0 <> wii Then
     If wii > wi And wii < Len(fn) Then
       wextension = vl & _
            UCase(Mid(fn, wii + 1)) & vl
       If InStr(ExcludeThisExtensions, _
                wextension) > 0 Then
          DontCountExtension = True
       End If
    End If
 End If

End Function

Sub ProcessFolder(ParentPath$, ResultTree$, _
    LocalPath$)
Dim f$, i&, ws$, WSS$, WB As Boolean
Dim CommonUmbrella$, CommonResult$
Dim TargetCommonUmbrella$
Dim FolderStack$(), FileStack$()
Dim TargetFolderStack$(), TargetFileStack$()
Dim WTarget$
Dim LocalPathInProgressStashed$
Dim Excep$

If STOP_commanded Or _
   ExceptionInProcessFolder <> "" _
   Then Exit Sub
   
On Error GoTo he

'-----------------------------------------------
' process statistics:
i = GetTickCount - prof_StartTime
prof_lblTimeElapsed.Caption = _
   CStr(i)
prof_lblAverageSpeed.Caption = _
   Format(0.001 * BytesCounter / i, "#.000")
'-----------------------------------------------
   
profold_Deepness = profold_Deepness + 1
   
LocalPathInProgressStashed = LocalPathInProgress
LocalPathInProgress = LocalPath
prof_lblLocalPath.Caption = _
    "..." & Right(LocalPathInProgress, 38)
    


ReDim FolderStack(0)
ReDim FileStack(0)
ReDim TargetFolderStack(0)
ReDim TargetFileStack(0)

CommonUmbrella = ParentPath & LocalPath
TargetCommonUmbrella = TargetsPathedParent & _
      LocalPath

'CommonResult = ParentPath & "\" & ResultTree  'may need, but only "once";

If "L" = glCompare_Files Then
   f = Dir(CommonUmbrella & "\" & _
           glCompareFiles_Source, _
           p_AllAttr)
   AddNewString FileStack, f
   FilesInSource = FilesInSource + 1
   GoTo ContinueFileOrFolder
End If

'=========== MAKE FILES' AND FOLDERS' STACKS ==================================================
'find first file:
f = Dir(CommonUmbrella & "\*.*", p_AllAttr)
Do While f <> ""
   'this is a danger: no other part of
   'program can use Dir at this time:
   'remming out this,
   'however, may cause dead lock:
   'DoEvents
   If Left(f, 1) = "." Then
      If Len(f) > 1 Then
         If ".." <> f Then
            PeriodNote = PeriodNote & _
               "Skipping units with names " & _
               "starting with period. " & _
               "Unit = " & CommonUmbrella & "\" & f & ve
            GoTo SkippedUnit
         End If
      End If
   End If
             
   If (GetAttr(CommonUmbrella & "\" & f) And _
      vbDirectory) = vbDirectory Then
      If f <> "." And f <> ".." Then
         AddNewString FolderStack, f
         FoldersInSource = _
              FoldersInSource + 1
      End If
   Else
      AddNewString FileStack, f
      FilesInSource = FilesInSource + 1
   End If
SkippedUnit:
   f = Dir
   If STOP_commanded Then GoTo ExitSub
Loop

DoEvents
'find redundant stuff in target folder
'1) make stacks first:
f = Dir(TargetCommonUmbrella & "\*.*", p_AllAttr)
Do While f <> ""
   'this is a danger: no other part of
   'program can use Dir at this time:
   'remming this, however, may cause dead lock:
   'DoEvents
   If (GetAttr(TargetCommonUmbrella & "\" & f) And _
      vbDirectory) = vbDirectory Then
      If f <> "." And f <> ".." Then _
         AddNewString TargetFolderStack, f
   Else
      AddNewString TargetFileStack, f
   End If
   f = Dir
   If STOP_commanded Then GoTo ExitSub
Loop

' 2) find redundant files:
For i = 1 To UBound(TargetFileStack)
    
    
    WTarget = CommonUmbrella & "\" & _
           TargetFileStack(i)
    If Dir(WTarget, p_AllAttr) = "" Then
       If Not DontCountExtension(WTarget) Then
          RedundantFiles = RedundantFiles + 1
          S_AND_T_UNMATCHED_FILES = _
            S_AND_T_UNMATCHED_FILES + 1
          mic_fl "  Redundant file      " & _
             LocalPath & "\" & TargetFileStack(i)
       Else
          SkippedTargetFiles = _
             SkippedTargetFiles + 1
       End If
    End If
    DoEvents
    If STOP_commanded Then GoTo ExitSub
Next

' 3) find redundant folders:
For i = 1 To UBound(TargetFolderStack)
   If Dir(CommonUmbrella & "\" & _
          TargetFolderStack(i), p_AllAttr) _
          = "" Then
       
      'check is it empty:
      If IsDirEmpty(TargetCommonUmbrella$ & "\" & _
                    TargetFolderStack(i)) Then
         ws = "  Redundant and empty folder   "
      Else
         ws = "  Redundant folder    "
      End If
      RedundantFolders = RedundantFolders + 1
      S_AND_T_UNMATCHED_FOLDERS = _
         S_AND_T_UNMATCHED_FOLDERS + 1
      mic_fo ws & LocalPath & "\" & _
             TargetFolderStack(i)
              
    End If
    DoEvents
    If STOP_commanded Then GoTo ExitSub
Next
'=========== ef MAKE FILES' AND FOLDERS' STACKS  ================================================


ContinueFileOrFolder:

'=========== RPOCESSING FILE PART OF THIS DIRECTORY ===========================
For i = 1 To UBound(FileStack)
    DoEvents
    prof_lblCounter.Caption = CStr(FilesInSource)

    'this object must be submitted before:
    ws = FileStack(i)
    prof_lblCurrentUnit.Caption = _
        "..." & Right(ws, 38)
    fcomp_FindSourceUnits ws, True, _
          ExceptionInProcessFolder
    If ExceptionInProcessFolder <> "" Then _
       GoTo ExitSub
    If STOP_commanded Then GoTo ExitSub
Next
'=========== ef RPOCESSION FILES PART OF THIS DIRECTORY =========================
     

'========= RECURSION INTO FOLDERS: ===========================================================
For i = 1 To UBound(FolderStack)
       DoEvents
       WSS = FolderStack(i)
       ws = LocalPath & "\" & WSS
       prof_lblCurrentUnit.Caption = _
             "..." & Right(WSS, 38)
       
       WB = fcomp_FindSourceUnits(WSS, _
            False, ExceptionInProcessFolder)
       
       If ExceptionInProcessFolder <> "" Then _
          GoTo ExitSub
       If WB Then
          EnteredFolders = EnteredFolders + 1
          ProcessFolder ParentPath, _
          ResultTree, ws
       End If
          'to have a correct info:
          'LocalPathInProgress = LocalPath
       If STOP_commanded Then GoTo ExitSub   'to make stop "smoother"
Next
'========= ef RECURSION INTO FOLDERS =========================================================
   
   
ExitSub:
     profold_Deepness = profold_Deepness - 1
     LocalPathInProgress = LocalPathInProgressStashed
Exit Sub


he: ExceptionInProcessFolder = "Exception " & _
        Err.Number & " " & Err.Description & ve & _
        "in ProcessFolder."
     Resume ExitSub
   
End Sub


'adds next string to not fixed size array
Sub AddNewString(StringsArray$(), NewString$)
    Dim i&
    i = UBound(StringsArray)
    ReDim Preserve StringsArray(i + 1)
    StringsArray(i + 1) = NewString
End Sub

