Attribute VB_Name = "modConsole"
Option Explicit

Public Console_HalfTextLimit&
Public Const Console_FName$ = "console.txt"
Public con_SuppliedConsole As TextBox

Public Sub con_SuppyTextBox(obj As TextBox)
Set con_SuppliedConsole = obj
End Sub

'EXCEP  only if cannot save to console file.
'
'DESCR  Makes sure that txtControl object text
'       never exceeds Console_HalfTextLimit * 2
'
'INPUT  s$ - source text
'       txtControl - TextBox
'
Sub Console(s$, txtControl As TextBox)
Dim TextLength&, wi&, FragmentLength&

'assume that nothing is printed before
'form is loaded:
'If Not MainFormIsLoaded Then Exit Sub

With txtControl
TextLength = Len(.Text)
FragmentLength = Len(s)
If FragmentLength = 0 Then Exit Sub


If FragmentLength > Console_HalfTextLimit Then
   OpenAndAppendToFile App.Path & "\" & Console_FName, _
       .Text & Left(s, FragmentLength - Console_HalfTextLimit)
       .Text = Right(s, Console_HalfTextLimit)
ElseIf TextLength > Console_HalfTextLimit Then
   OpenAndAppendToFile App.Path & "\" & Console_FName, _
       Left(.Text, TextLength - Console_HalfTextLimit)
       .Text = Right(.Text, Console_HalfTextLimit) & s
Else
      
      'KK.later: assume that this
      'is a correct method:
      .SelStart = Len(.Text)
      .SelText = s
      '.SelStart = Len(.text)

      'this is ... 's method, but I am not sure: ...
      '.SelStart = TextLength
      '.SelLength = 1  '=one
      '.SelText = S
   
End If
   
'to avoid bad "flicker", put cursor at the
'beginning of the string;
TextLength = Len(.Text)
If TextLength > 0 Then
    wi = instrrevv(Left(.Text, TextLength - 1), vl) + 1
    If wi = 1 Then
        .SelStart = 0
    Else
        .SelStart = wi
    End If
End If
End With

End Sub

'EXCEP free
Public Sub DeleteConsole()
On Error Resume Next
Kill App.Path & "\" & Console_FName
End Sub

Public Sub pl(s$)
Console s & ve, con_SuppliedConsole
End Sub



Public Sub pll(s$)
Console ve & s & ve, con_SuppliedConsole
End Sub


Public Sub SaveConsole()
If Not con_SuppliedConsole Is Nothing Then _
   OpenAndAppendToFile App.Path & "\" & _
       Console_FName, con_SuppliedConsole.Text
End Sub


