Attribute VB_Name = "Strings"
Option Explicit
 



'EXCE free
'NOTE slow
'YELD no
'
Public Function a_InstrRev$(StartPos&, s$, pat$)
  a_InstrRev = getNthOccurencePosition&( _
       pat, s, StartPos, 1, 1, 0)
End Function




'EXCEP  free
'DESC   pat_tern  - which to look for
'       s         - where to look for
'       s_tart    - where to start
'                   if <1 then from 1 for normal
'                                     direction
'                                   0 for reverse
'       d_ir      - direction
'                   0 - normal, 1 or other -reverse
'       n         - how many to search;
'                 - if n<1, then
'                   search as many as are;
'       re_verse  - 0 - search for pattern
'                  -1 - search for not-pattern
'                       any sequence which is not
'                       pattern;
'
'OUTPUT 0         - if no succes
'       position  - if success
'
'YELD no
'
Public Function getNthOccurencePosition&( _
       pat_tern$, s$, s_tart&, _
       d_ir&, n&, re_verse&)
Dim I&, iStep&, iStart&, iEnd&, iLen&, iOcc&
Dim PatternLength&
Dim PatternStep&

PatternLength = Len(pat_tern)
iLen = Len(s)
If 0 = iLen Or PatternLength = 0 Then _
   Exit Function

Select Case d_ir
   Case 0:  'normal direction
        iStart = s_tart
        If s_tart < 1 Then iStart = 1
        iStep = 1
        iEnd = iLen
   Case Else:  'reverse direction
        iStart = s_tart
        If s_tart < 1 Then iStart = Len(s)
        iStep = -1
        iEnd = 1
End Select
PatternStep = iStep * PatternLength

iOcc = 0
I = iStart

ContinueLoop:
  Select Case iStep
    Case 1
       If I > iEnd Then GoTo LoopExit
    Case -1
       If I < iEnd Then GoTo LoopExit
  End Select
   
  If Mid(s, I, PatternLength) = pat_tern Then
           
      If Not re_verse Then
        iOcc = iOcc + 1
        If iOcc = n Then
           getNthOccurencePosition = I
           Exit Function
        End If
      End If
      I = I + PatternStep
   
  Else
   
      If re_verse Then
        iOcc = iOcc + 1
        If iOcc = n Then
           getNthOccurencePosition = I
           Exit Function
        End If
      End If
      I = I + iStep
  
  End If
  GoTo ContinueLoop
 
LoopExit:
    
End Function


'OUTP  returns string xxxxxx surrounded by
'      pattern pat as in sketch below:
'
'      pat xxxxx pat
'           ^     ^
'
'      pat is a single charater
'
'      hat ^ denotes start_pos -ition.
'
Public Function a_IsolateStringByChar( _
                s$, start_pos&, pat$)
Dim beg_in&, e_nd&
  Dim StartPos&
  Dim ls&, lpat&
  

  ls = Len(s)
  lpat = Len(pat)
  If 0 = lpat Or 0 = ls Or lpat > 1 _
     Then Exit Function
  
  If 0 > start_pos Or ls < start_pos Then
     'make a courtesy fix:
     StartPos = 1
  Else
     StartPos = start_pos
  End If
  'Now, iput parameters are well-defined.
     
    
  '==========================================
  ' find left tip = beg_in:
  '------------------------------------------
  beg_in = a_InstrRev(StartPos, s, pat)
  If 0 = beg_in Then
     beg_in = 1
     GoTo beg_and_start_in_place
  End If
   
  'pattern found "on the left":
  If StartPos < beg_in + lpat Then
     'beg_in is inside of right limitor;
     If 1 = beg_in Then
        Exit Function
     Else
        
        'move start to "paaa--tern xxxxx" area:
        StartPos = beg_in - lpat
        If 1 > StartPos Then
           Exit Function
        Else
           'now StartPos is inside of "pat xxxx"
           beg_in = a_InstrRev(StartPos, s, pat)
           
           'the case of StartPos inside of pat:
           If StartPos = beg_in Then Exit Function
        End If
     End If
  End If
  beg_in = beg_in + lpat
 '===========================================
   
beg_and_start_in_place:
 
 'Now, it is clear that xxxx area is not empty
 '     beg_in is a beginning of xxxx area,
 '     and StarPos is inside of xxxx area.
 
 e_nd = InStr(StartPos, s, pat)
 If 0 = e_nd Then e_nd = Len(s) + 1
 
 a_IsolateStringByChar = _
   Mid(s, beg_in, e_nd - beg_in)
 
 
End Function


